
#property copyright "Copyright  2013,CORONFOREX SOFT- support@coronforex.com"
#property link      "http://www.coronforex.com"

#property indicator_separate_window
#property indicator_minimum 40.0
#property indicator_maximum 62.0
#property indicator_levelcolor DarkViolet
#property indicator_levelstyle 0
#property indicator_buffers 8
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_width2 3
#property indicator_color3 Green
#property indicator_width3 3
#property indicator_color4 Gold
#property indicator_width4 3
#property indicator_color5 Orange
#property indicator_color6 Gold
#property indicator_color7 Black
#property indicator_color8 Black


int Gi_76;
double Gda_80[];
double Gd_84;
double Gda_92[];
double Gda_96[];
double G_ibuf_100[];
double G_ibuf_104[];
double G_ibuf_108[];
double G_ibuf_112[];
double G_ibuf_116[];
extern double len = 1.5;
extern double factor = 2.0;
extern int threshold = 80;

int init() {
     
      IndicatorShortName("coronforex");
      SetIndexBuffer(0, G_ibuf_100);
      SetIndexBuffer(1, G_ibuf_104);
      SetIndexStyle(1, DRAW_ARROW, EMPTY, 3);
      SetIndexArrow(1, 167);
      SetIndexBuffer(2, G_ibuf_108);
      SetIndexStyle(2, DRAW_ARROW, EMPTY, 3);
      SetIndexArrow(2, 167);
      SetIndexBuffer(3, G_ibuf_112);
      SetIndexStyle(3, DRAW_ARROW, EMPTY, 3);
      SetIndexArrow(3, 167);
      SetIndexBuffer(4, G_ibuf_116);
      SetIndexStyle(4, DRAW_ARROW, EMPTY, 3);
      SetIndexArrow(4, 167);
      return (0);
  
  
}

void start() {
   double Ld_8;
   double Ld_16;
   double Ld_24;
   double Ld_32;
   double Ld_40;
   double Ld_48;
   double Ld_56;
   double Ld_64;
   double Ld_72;
   double Ld_80;
   double Ld_88;
   double Ld_96;
   double Ld_104;
   double Ld_112;
   double Ld_120;
   double Ld_128;
   double Ld_136;
   double Ld_144;
   double Ld_152;
   double Ld_160;
   double Ld_168;
   double Ld_176;
   double Ld_184;
   double Ld_192;
   double Ld_200;
   double Ld_208;
   double Ld_216;
 
   int Li_4 = IndicatorCounted();
  
   if (Li_4>0) Li_4--;
   int Li_0 = Bars- Li_4;
   double Ld_224 = Bars-10;
   for (int Li_232 = Ld_224; Li_232 >= 0; Li_232--) {
      if (Ld_16==0) {
         Ld_16 = 1.0;
         Ld_24 = 0.0;
         Ld_8 = 6.0;
         Ld_88 = 100.0 * ((High[Li_232]+ Low[Li_232]+ Close[Li_232])/3.0);
         Ld_104 = 0.3333333333;
         Ld_112 = 1-Ld_104;
      } else {
         if ( Ld_8<= Ld_16) Ld_16 = Ld_8+1.0;
         else Ld_16 += 1.0;
         Ld_96 = Ld_88;
         Ld_88 = 100.0 * ((High[Li_232]+ Low[Li_232]+ Close[Li_232])/3.0);
         Ld_40 = Ld_88-Ld_96;
         Ld_120 = Ld_112 * Ld_120 + Ld_104 * Ld_40;
         Ld_128 = Ld_104 * Ld_120 + Ld_112 * Ld_128;
         Ld_48 = len*Ld_120 - Ld_128 / factor;
         Ld_136 = Ld_112 * Ld_136 + Ld_104 * Ld_48;
         Ld_216 = Ld_104 * Ld_136 + Ld_112 * Ld_216;
         Ld_56 = len * Ld_136 - Ld_216 / factor;
         Ld_144 =Ld_112 * Ld_144 + Ld_104 * Ld_56;
         Ld_160 =Ld_104 * Ld_144 + Ld_112 * Ld_160;
         Ld_64 = len * Ld_144 - Ld_160 / factor;
         Ld_168 = MathAbs(Ld_40) * Ld_104 + Ld_112 * Ld_168;
         Ld_176 = Ld_104 * Ld_168 + Ld_112 * Ld_176;
         Ld_72 = len * Ld_168 - Ld_176 / factor;
         Ld_184 = Ld_112 * Ld_184 + Ld_104 * Ld_72;
         Ld_192 = Ld_104 * Ld_184 + Ld_112 * Ld_192;
         Ld_152 =len * Ld_184 - Ld_192 / factor;
         Ld_200 = Ld_112 * Ld_200 + Ld_104 * Ld_152;
         Ld_208 = Ld_104 * Ld_200 + Ld_112 * Ld_208;
         Ld_80 = len * Ld_200 - Ld_208 / factor;
         if (Ld_8 == Ld_16 && Ld_88 != Ld_96) Ld_24 = 1.0;
         if (Ld_8 == Ld_16 && Ld_24 == 0.0 ) Ld_16 = 0.0;
      }
      if (Ld_8 < Ld_16 && Ld_80 > 0.0000000001) {
         Ld_32 = 50.0 * (Ld_64 / Ld_80 + 1.0);
         if (Ld_32 > 100.0) Ld_32 = 100.0;
         if (Ld_32 < 0.0) Ld_32 = 0.0;
      } else Ld_32 = 50.0;
      Gda_80[Li_232] = Ld_32;
      Gda_92[Li_232] = Ld_32;
      Gda_96[Li_232] = Ld_32;
      Gd_84 = Ld_32;
      if (Gd_84 > threshold) G_ibuf_104[Li_232] = 50.0;
      else G_ibuf_104[Li_232] = EMPTY_VALUE;
      if (Gd_84 < (100-threshold)) G_ibuf_108[Li_232] = 50.0;
      else G_ibuf_108[Li_232] = EMPTY_VALUE;
      if (G_ibuf_104[Li_232] == EMPTY_VALUE && G_ibuf_108[Li_232] == EMPTY_VALUE) G_ibuf_112[Li_232] = 50.0;
   }
 
}

void deinit() {
  
}